#TEMPLATE(PDSqlFilterClass,'PD Sql Filter Template'),FAMILY('ABC'),FAMILY('CW20')
#!---------------------------------------------------------------------------
#EXTENSION(PDSQLFilterGlobal,'PD SQL Filter Global Extension'),APPLICATION
#PREPARE
  #CALL(%pdMakeHead,'PDSQLFilterGlobal','PD SQL Filter Global Extension')
#ENDPREPARE
#INSERT(%pdHead)
#BOXED('Hidden Prompts'),AT(0,0,0,0),WHERE(%False),HIDE
  #PROMPT('',@s10),%pdTemplateVersion,AT(0,0,0,0)
#ENDBOXED
#SHEET
#!-- PROMPT SECTION
#TAB('General')
  #DISPLAY('There are no Global prompts')
#ENDTAB
#ENDSHEET
#AT(%BeforeGenerateApplication)
  #IF(VAREXISTS(%Category))
    #!-- Note the class reader knows the category of the library from Paran in !ABCIncludefile(Param).  This
    #!-- tells the template what to do with it - adding the category to the %Category and then the link/dll modes for
    #!-- all items of this category.
    #CALL(%AddCategory(ABC),'PDSQLFILTER')
    #CALL(%SetCategoryLocation(ABC),'PDSQLFILTER','PDSQLFILTER',,)
  #ENDIF
  #!-- Check for presence of the class.  If not there, force a reread of header files.
  #DECLARE(%TestOK)
  #SET(%TestOK,0)
  #CALL(%ReadABCFiles(ABC))
  #FOR(%pClassName)
    #IF(UPPER(%pClassName)=UPPER('PDSQLFilterCT'))
      #SET(%TestOK,1)
      #BREAK
    #ENDIF
  #ENDFOR
  #IF (%TestOK=0)
    #CALL(%ForceReadABCFiles(ABC))
  #ENDIF
#ENDAT
#AT(%CustomGlobalDeclarations)
  #!
  #!-- Determine the template chain.
  #IF(NOT VAREXISTS(%AppTemplateFamily))
    #IF(SUB(%CWTemplateVersion,2,1)<='2' )
      #SET(%pdTemplateVersion,'CLARION')
    #ELSE
      #SET(%pdTemplateVersion,'ABC')
    #ENDIF
  #ELSE
    #SET(%pdTemplateVersion,%AppTemplateFamily)
  #ENDIF
  #ASSERT(%pdTemplateVersion,'Template Chain not assigned.')
  #!
  #!-- Determine variable status: external or local.
  #DECLARE(%pdExternal)
  #IF(%GLobalExternal)
    #SET(%PDExternal,',EXTERNAL,DLL(DLL_Mode)')
  #ENDIF
  #!
  #!-- Force include file to be added to global includes.
  #IF(%pdTemplateVersion='ABC' )
    #CALL(%AddModuleIncludeFile(ABC),'PDSQLFilterCT',1)
  #ENDIF
  #IF(NOT VAREXISTS(%ABCVersion))
    #DECLARE(%ABCVersion)
  #ENDIF
  #!
  #!-- Add pragmas to project file if using the Clarion chain and early versions of ABC library.
  #IF(%pdTemplateVersion='CLARION' AND NOT VAREXISTS(%Category))
    #IF(%GlobalExternal=1 AND %ProgramExtension='DLL')
      #PDEFINE('_PDSQLFILTERDLLMode_',1)
    #ELSE
      #PDEFINE('_PDSQLFILTERDLLMode_',0)
    #ENDIF
    #IF(NOT %GlobalExternal)
      #PDEFINE('_PDSQLFILTERLinkMode_',1)
    #ELSE
      #PDEFINE('_PDSQLFILTERLinkMode_',0)
    #ENDIF
  #ENDIF
  #!
#ENDAT
#AT(%GlobalData)
#!-- Add any global data required, with external attribute if needed.
#!MyField        MYDATADEFINITION%pdExternal
#ENDAT
#! --------------------------------------------------------------------------
#AT(%BeforeGlobalIncludes)
  #!-- Add include file in CLARION chain.
  #IF(%pdTemplateVersion='CLARION')
   INCLUDE('PDSQLFILTER.INC'),ONCE
  #ENDIF
#ENDAT
#! --------------------------------------------------------------------------
#AT(%ProgramSetup)
  #!-- Initialization code
#ENDAT
#! --------------------------------------------------------------------------
#AT(%DLLExportList)
 #!-- Export items from CLARION chain.  ABC handles this using Categories.
 #CALL(%ExportLibraryGroup)
#ENDAT
#! --------------------------------------------------------------------------
#!
#! --------------------------------------------------------------------------
#!-- Add your code or control template here.
#CONTROL(PDSQLFilterControl, 'PD SQL FIlter Controls'),MULTI,DESCRIPTION('PD SQL FIlter Controls '&%ActiveTemplateInstance& - %pdDescription),REQ(PDSQLFilterGlobal),PROCEDURE,REQ(BrowseBox(ABC))
#! --------------------------------------------------------------------------
#INSERT(%pdPrepareOopClass)
  #PREPARE
    #CALL(%pdMakeHead,'PDSQLFilterControl','PD SQL FIlter Controls')
  #ENDPREPARE
#INSERT(%pdHead)  
  #!-- This will display in the embed tree.  It is here only if multiple instances are allowed.
  #PROMPT('Description',@s80),%pdDescription,REQ
#SHEET
#!-- PROMPTs
  #INSERT(%pdClassPrompts)
#ENDSHEET
#!--------------------------------------------------------------------------
#!-- Control Template Controls
  CONTROLS
    STRING('Field:'),AT(,,10),USE(?FieldStr),TRN,LEFT
    STRING('Action:'),AT(165,0,26,10),USE(?ActionStr)
    STRING('Text:'),AT(70,0,31,10),USE(?TextStr),TRN
    LIST,AT(-235,12,161,12),USE(QueryField),FLAT,VSCROLL,TIP('Drag from just above this field to populate a value in the query builder.'),DROP(10),FROM(' ')
    LIST,AT(165,0,65,12),USE(QueryAction),FLAT,VSCROLL,DROP(10),FROM(' ')
    ENTRY(@s255),AT(70,0,148,12),USE(Alpha),FLAT,TIP('Entries in the list box may be dragged here.'),DROPID('1')
    BUTTON('&T'),AT(84,16,29,12),USE(?TextAdd),TIP('Send text portion to query builder')
    BUTTON('&All'),AT(34,0,29,12),USE(?EnterAllButton),TIP('Send entire line to query builder')
    BUTTON('BETWEEN'),AT(-353,0,45,12),USE(?SendBetween)
    BUTTON('CONTAINS'),AT(48,0,45,12),USE(?SendContains)
    BUTTON('UPPER'),AT(48,0,45,12),USE(?SendUpper)
    BUTTON('LOWER'),AT(52,0,45,12),USE(?SendLower)
    BUTTON('EXISTS'),AT(48,0,45,12),USE(?SendExists)
    BUTTON('COUNT'),AT(48,0,45,12),USE(?SendCount)
    BUTTON('AND'),AT(-244,16,27,12),USE(?SendAnd)
    BUTTON('OR'),AT(28,0,27,12),USE(?SendOr)
    BUTTON('IN'),AT(32,0,27,12),USE(?SendIn)
    BUTTON('NOT'),AT(28,0,27,12),USE(?SendNot)
    BUTTON('LIKE'),AT(28,0,27,12),USE(?SendLike)
    BUTTON('MIN'),AT(28,0,27,12),USE(?SendMin)
    BUTTON('MAX'),AT(32,0,27,12),USE(?SendMax)
    BUTTON('AVG'),AT(28,0,27,12),USE(?SendAvg)
    BUTTON('SUM'),AT(28,0,27,12),USE(?SendSum)
    BUTTON('ALL'),AT(28,0,27,12),USE(?SendAll)
    BUTTON('='),AT(-260,16,27,12),USE(?SendEqual)
    BUTTON('<< >'),AT(28,0,27,12),USE(?SendNotEqual)
    BUTTON('<<'),AT(32,0,27,12),USE(?SendLess)
    BUTTON('>'),AT(28,0,27,12),USE(?SendGreater)
    BUTTON('<<='),AT(28,0,27,12),USE(?SendLessEqual)
    BUTTON('>='),AT(28,0,27,12),USE(?SendGreaterEqual)
    BUTTON('('),AT(32,0,27,12),USE(?SendOpenPar)
    BUTTON(')'),AT(28,0,27,12),USE(?SendClosePar)
    BUTTON(','),AT(28,0,27,12),USE(?SendComma)
    BUTTON('.'),AT(28,0,27,12),USE(?SendPeriod)
    TEXT,AT(-260,16,288,46),USE(QueryBuilder),SKIP,BOXED,FLAT,VSCROLL
    BUTTON('&Load'),AT(319,-4,29,12),USE(?LoadQuery)
    BUTTON('&Save'),AT(34,0,29,12),USE(?SaveQuery)
    BUTTON('&Reset Query'),AT(-34,20,64,12),USE(?ClearAll)
    BUTTON('&Execute Query'),AT(0,16,64,12),USE(?ExecQuery),TIP('Execute the current query. If there is an error, it will be displayed.')
  END
#ATSTART
  #!
  #IF(%pdTemplateVersion='CLARION')
    #IF(NOT VAREXISTS(%ProcsCalled))
      #DECLARE(%ProcsCalled),UNIQUE
    #ENDIF
  #ENDIF
  #IF(NOT VAREXISTS(%OOPCONSTRUCT))
    #DECLARE(%OOPConstruct)
    #DECLARE(%ByteCount,LONG)
    #DECLARE(%IncludePrototype,LONG)
    #DECLARE(%ModuleIncludeList),UNIQUE
  #ENDIF
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC),'Default')
  #IF(%pdTemplateVersion='ABC')
    #CALL(%SetOOPDefaults(ABC),'PDSQLFilterC'&%ActiveTemplateInstance,'PDSQLFilterCT')
  #ELSE
    #DECLARE(%pdControl)
    #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
      #SET(%pdControl,%ControlInstance)
    #ENDFOR
    #CALL(%SetOOPDefaults(ABC),'PDSQLFilterC'&%ActiveTemplateInstance,'PDSQLFilterCT')
  #ENDIF
  #!
  #DECLARE(%FilterField),MULTI,UNIQUE
  #DECLARE(%FilterFieldNo,%FilterField)
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance AND %ControlType<>'STRING' AND %ControlType<>'PROMPT')
    #ADD(%FilterField,%Control)
    #SET(%FilterFieldNo,'eFld:'&CHOOSE(SUB(%ControlOriginal,1,1)='?',SUB(%ControlOriginal,2,LEN(%ControlOriginal)-1),%ControlOriginal) )
  #ENDFOR
  #DECLARE(%QueryFM)
  #SET(%QueryFM,'Access:'&%SqlSavedQueryFile)
#ENDAT
#LOCALDATA
  QueryBuilder     STRING(10000)                         !
  QueryField       STRING(250)                           !
  QueryAction      STRING(250)                           !
  Alpha            STRING(1000)                          !
#ENDLOCALDATA
#!
#AT(%DataSection)
_QueryG            GROUP(SavedQueryGT)
                   END
#ENDAT
#!--------------------------------------------------------------------------
#AT(%AfterOpeningWindow)
#!--------------------------------------------------------------------------
_QueryG.FM &= %QueryFM
_QueryG.Category=%SqlSavedQueryCategory
%ThisObjectName.Init(%SqlBrowse,%SqlQueryFld,%BrowseListQueue,_QueryG)
SELF.AddItem(%ThisObjectName.WindowComponent)
#ENDAT
#!--------------------------------------------------------------------------
#AT(%PDSQLFILTERMethodCodeSection,%ActiveTemplateInstance),PRIORITY(2500),WHERE(%pClassMethod='Init')
#!--------------------------------------------------------------------------
  #FOR(%ExcludeFiles)
    #FIND(%File,%ExcludeFile)
    #IF(%FileName) 
SELF.AddExcludeFile(%FileName)  
    #ELSE
SELF.AddExcludeFile('%ExcludeFile')  
    #ENDIF
  #ENDFOR
  #FOR(%ExcludeFields)
SELF.AddExcludeField('%ExcludeField')  
  #ENDFOR
#ENDAT
#!--------------------------------------------------------------------------
#AT(%PDSQLFILTERMethodCodeSection,%ActiveTemplateInstance),PRIORITY(7500),WHERE(%pClassMethod='Init')
#!--------------------------------------------------------------------------
  #FOR(%FilterField)
SELF.AddField(%FilterFieldNo,%FilterField)
  #ENDFOR
  #FOR(%Joins)
SELF.AddJoin(%JoinFile,'%JoinExpression')  
  #ENDFOR 
#ENDAT
#!
#!--------------------------------------------------------------------------
#AT(%GatherObjects)
#!--------------------------------------------------------------------------
  #CALL(%AddObjectList(ABC), 'Default')
#ENDAT
#!
#!--------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
#!--------------------------------------------------------------------------
  #IF(%pdTemplateVersion='ABC' AND %CWTemplateVersion<'v6.1')
    #ADD(%GlobalIncludeList,'PDSQLFILTER.INC')
  #ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#!--------------------------------------------------------------------------
#AT(%LocalDataClasses)
#!--------------------------------------------------------------------------
  #CALL(%GenerateClass(ABC),'Default')
#ENDAT
#!
#!--------------------------------------------------------------------------
#AT(%DataSectionAfterWindow)
#!--------------------------------------------------------------------------
#! Handle CLARION templae chain prior to c6
  #IF(%pdTemplateVersion='CLARION' AND SUB(%CWVersion,1,2)='55')
%[20]ThisObjectName CLASS(PDSQLFilterCT)
#! Add any conditional procedures
%[20]NULL END
  #ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#AT(%PDSQLFILTERMethodCodeSection,%ActiveTemplateInstance),PRIORITY(7500),WHERE(%pClassMethod='Translate')
  #IF(%EnableRuntimeTranslator)
Translator.TranslateWindow(pWin)  
  #ENDIF        
#ENDAT        
#AT(%PDSQLFILTERMethodCodeSection,%ActiveTemplateInstance),PRIORITY(7500),WHERE(%pClassMethod='TranslateString')
  #IF(%EnableRuntimeTranslator)
ReturnValue=Translator.TranslateString(pStr)  
  #ENDIF        
#ENDAT        
#AT(%PDSQLFILTERMethodCodeSection,%ActiveTemplateInstance),PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())
#!-----------------------------------------------------------------------------------------------------------
#! Generate Parent Calls
  #CALL(%GenerateParentCall(ABC))
#ENDAT
#!
#!--------------------------------------------------------------------------
#AT(%LocalProcedures)
#!-----------------------------------------------------------------------------------------------------------
#! Generate Virtual Procedures
  #CALL (%GenerateVirtuals(ABC), 'Default', 'Local Objects|PDSQLFILTER Objects|' & %pdTplDescription  & '-' & %ThisObjectName & ' ','%PDSQLFILTERVirtuals(PDSqlFilterClass)')
#ENDAT
#!
#! --------------------------------------------------------------------------
#GROUP(%PDSQLFILTERVirtuals, %TreeText, %DataText, %CodeText)
#! --------------------------------------------------------------------------
#EMBED(%PDSQLFILTERMethodDataSection,'PDSQLFilterCT Method Data Section'),%ActiveTemplateInstance,%pClassName,%pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(,%FixClassName(%FixBaseClassToUse('Default'))),TREE(%TreeText & %DataText)
#?%NULL
  #?CODE
  #EMBED(%PDSQLFILTERMethodCodeSection,'PDSQLFilterCT Method Executable Code Section'),%ActiveTemplateInstance,%pClassName,%pClassMethod,%pClassMethodPrototype,PREPARE(,%FixClassName(%FixBaseClassToUse('Default'))),TREE(%TreeText & %CodeText)
#!
#! --------------------------------------------------------------------------
#! --------------------------------------------------------------------------
#GROUP(%ExportLibraryGroup)
#! --------------------------------------------------------------------------
  #IF(NOT (%ProgramExtension='DLL' AND NOT %GlobalExternal))
    #RETURN
  #ENDIF
  #IF(NOT VAREXISTS(%ExpLineNumber))
    #DECLARE(%ExpLineNumber)
  #ENDIF
  #IF(%pdTemplateVersion='ABC' OR %CWTemplateVersion>='v6.1')
     #SET(%ExpLineNumber,'?')
  #ELSE
    #IF(%ExpLineNumber=0)
EXPORTS
    #END
    #SET(%ExpLineNumber,%ExpLineNumber + 1)
  #ENDIF
;Start of PD MakeClass Template Data exports
#!
#!-- Add any data exports.  Increment %ExpLineNumber for early CLARION versions.
#!  $MyField                                             @%ExpLineNumber
#!  #IF(%CWTemplateVersion<'v6.1' AND %pdTemplateVersion='CLARION')
#!    #SET(%ExpLineNumber,%ExpLineNumber + 1)
#!  #ENDIF
#!
  #!
  #IF(%pdTemplateVersion='CLARION')
;Start PD SQL FIlter Controls Class Exports
    #SUSPEND
    #FOR(%pClassName),WHERE(SUB(UPPER(%pClassIncFile),LEN(%pClassIncFile)-LEN('PDSQLFILTER.INC')+1,LEN('PDSQLFILTER.INC'))='PDSQLFILTER.INC') #!(UPPER(%pClassName)='PDSQLFilterCT')
  #INSERT(%AddExpItem,'VMT$'&%pClassName)
  #INSERT(%AddExpItem,'TYPE$'&%pClassName)
      #FOR(%pClassMethod)
        #FOR(%pClassMethodPrototype),WHERE((~%pClassMethodPrivate OR %pClassMethodVirtual) AND  ~%pClassMethodInherited)
          #IF (%pClassMethodExtName)
            #IF(%CWTemplateVersion<'v6.1')
              #SET(%ExpLineNumber,%ExpLineNumber + 1)
            #ENDIF
  %[55]pClassMethodExtName @%ExpLineNumber
          #ELSE
            #IF(%CWTemplateVersion<'v6.1')
              #SET(%ExpLineNumber,%ExpLineNumber + 1)
            #ENDIF
  %[55](LINKNAME(%pClassMethod & %pClassMethodPrototype & ',' & %pClassMethodCallConv, %pClassName)) @%ExpLineNumber
          #ENDIF
        #ENDFOR
      #ENDFOR
      #FOR(%pClassImplements)
        #FIX(%pInterface,%pClassImplements)
        #FOR(%pInterfaceMethod)
          #FOR(%pInterfaceMethodPrototype)
            #IF(%CWTemplateVersion<'v6.1')
              #SET(%ExpLineNumber,%ExpLineNumber + 1)
            #ENDIF
  %[55](LINKNAME(%pInterfaceMethod & %pInterfaceMethodPrototype & ',' & %pInterfaceMethodCallConv, %pClassName, %pInterface, %pInterfaceMethodDefined)) @%ExpLineNumber
          #ENDFOR
        #ENDFOR
      #ENDFOR
    #ENDFOR
    #RESUME
  #ENDIF
;End PD SQL FIlter Controls Exports
#!
#!-------------------------------------------------------------------------
#GROUP(%AddExpItem,%ItemText,%UpperCase=%True)
#!-------------------------------------------------------------------------
  #IF(%CWTemplateVersion<'v6.1')
    #SET(%ExpLineNumber,%ExpLineNumber + 1)
  #ELSE
    #SET(%ExpLineNumber,'?')
  #ENDIF
  #IF(%UpperCase)
%[55](UPPER(%ItemText)) @%ExpLineNumber
  #ELSE
%[55]ItemText @%ExpLineNumber
  #ENDIF
#!
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%pdMakeHead,%xTplName,%xTplDescription)
#!-----------------------------------------------------------------------------------------------------------
  #IF (~VAREXISTS(%pdTplName))
      #INSERT(%pdMakeHeadHiddenPrompts)
  #ENDIF
  #SET (%pdTplName,%xTplName)
  #SET (%pdTplDescription,%xTplDescription)
#!
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%pdHead)
#!-----------------------------------------------------------------------------------------------------------
#IMAGE('pdLogo.jpg'), AT(,,60,30)
#DISPLAY (%pdTplName),AT(80,0)
#DISPLAY(%pdTplDescription),AT(80,8,120,16)
#DISPLAY ('<0169> 2010 ProDomus, Inc.'),AT(80,24,120,16)
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%pdMakeHeadHiddenPrompts)
#!-----------------------------------------------------------------------------------------------------------
  #BOXED(' Default MakeHead Prompts '),AT(0,0),WHERE(%False),HIDE
    #PROMPT('',@S50),%pdTplName
    #PROMPT('',@S100),%pdTplDescription
  #ENDBOXED
#RETURN
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%ParentCallValid),AUTO
#!-----------------------------------------------------------------------------------------------------------
   #IF (~VAREXISTS(%RtVal))
       #DECLARE(%RtVal)
   #ENDIF
   #INSERT (%ParentCallValid(ABC)),%RtVal
   #RETURN %RtVal
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%BaseClassToUse)
#IF(%UseDefaultABCBaseClass)
  #IF(%ActualDefaultBaseClassType)
    #RETURN(%ActualDefaultBaseClassType)
  #ELSE
    #ASSERT(%DefaultBaseClassType <> '','%BaseClassToUse: Symbol %DefaultBaseClassType is being returned empty ['&%ClassItem&']')
    #RETURN(%DefaultBaseClassType)
  #ENDIF
#ELSIF(%UseABCBaseClass)
  #RETURN(%ABCBaseClass)
#ELSIF(~%UseABCBaseClass)
  #RETURN(%ExtBaseClass)
#ENDIF
#ASSERT(%False,'%BaseClassToUse: IF clauses all missed')
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%pdClassPrompts)
#!-- INSTANCE PROMPTs
   #TAB('General')
    #BUTTON('Browse Info')
      #INSERT(%pdHead)
      #PROMPT('Browse Class',@s20),%SqlBrowse,REQ
      #PROMPT('Query FielD',FIELD),%SqlQueryFld,REQ
      #PROMPT('Browse Queue',@S80),%BrowseListQueue,REQ
    #ENDBUTTON
    #BUTTON('Query Info')
      #INSERT(%pdHead)
      #PROMPT('Saved Query File',FILE),%SqlSavedQueryFile,REQ
      #PROMPT('Saved Query Category',@s20),%SqlSavedQueryCategory,REQ,DEFAULT('%Procedure')
      #BUTTON('Test View Joins'),MULTI(%Joins,%joinFile)
        #PROMPT('Join File',FILE),%JoinFile,REQ
        #PROMPT('Join Expression',TEXT),%JoinExpression
      #ENDBUTTON
      #BUTTON('Exclude Files'),MULTI(%ExcludeFiles,%ExcludeFile)
        #PROMPT('File to Exclude:',FILE),%ExcludeFile,REQ
      #ENDBUTTON
      #BUTTON('Exclude Fields'),MULTI(%ExcludeFields,%ExcludeField)
        #PROMPT('Field to Exclude:',FIELD),%ExcludeField,REQ
      #ENDBUTTON
    #ENDBUTTON
#ENDTAB
  #TAB('&Classes')
    #INSERT(%pdHead)
    #WITH(%ClassItem,'Default')
      #INSERT(%ClassPrompts(ABC))
    #END
  #ENDTAB
#!-----------------------------------------------------------------------------------------------------------
#GROUP(%pdPrepareOopClass)
#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC),'Default')
  #CALL(%SetOOPDefaults(ABC),'PDSQLFilterC'&%ActiveTemplateInstance,'PDSQLFilterCT')
#ENDPREPARE
#BOXED('Hidden Prompts'),AT(0,0,0,0),WHERE(%False),HIDE
 #INSERT(%OOPHiddenPrompts(ABC))
#ENDBOXED
#!-----------------------------------------------------------------------------------------------------------
